      PROGRAM SENSITISATION

      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15,MAXNOD=700)

      CHARACTER*2 COMPT,CSOLV
      CHARACTER*20 PHASE
      CHARACTER*20 DATABASE,CPTFIL,OUTFIL
      CHARACTER*2 INIT_COMPONENT_NAME
      DOUBLE PRECISION TEMP,MOBLTY,DELX,DELT,ODELT,ORIGIN,TIME,SHIFT,MAX
      DOUBLE PRECISION VELOC,VOLM,DIS
      INTEGER INIT_NO_OF_COMPONENTS,INIT_COMPONENT_NO,ERFLAG,CHOICE
      INTEGER NNODES,I,NCOM,K,ANSWER,CHECK,NSOLV
      INTEGER EQUIL_NO_OF_PHASES
      INTEGER MT

      DOUBLE PRECISION CARBON,THICK,VLAST,VF
      DOUBLE PRECISION COMPO(MAXCPT)
      DOUBLE PRECISION DIFFU(MAXCPT,MAXCPT)
   
C     keep max of 700 points in composition profile
      DOUBLE PRECISION PROFIL(MAXCPT,0:MAXNOD)
      DOUBLE PRECISION CHEMPO(MAXCPT,0:MAXNOD)
      DOUBLE PRECISION MOBIL(MAXCPT,0:MAXNOD)
      DOUBLE PRECISION MOLVOL(MAXCPT)
      DOUBLE PRECISION MOB(MAXCPT,0:MAXNOD)
      DOUBLE PRECISION AIK(MAXCPT,MAXCPT,0:MAXNOD)
      DOUBLE PRECISION TEMP,PRESS

      COMMON / INPUT / COMPO
      COMMON / FSL / PROFIL,CHEMPO,MOBIL,MOLVOL,AIK
      COMMON / TP / TEMP,PRESS

      ERFLAG=0
C     Read (in order): component in solvent,phase,composition file,mpi file,output file
      
      OPEN(UNIT=1,FILE='DATA',STATUS='OLD')
      READ(1,*)
      READ(1,*)
      READ(1,*)
      READ(1,*)
      READ(1,*)
      READ(1,*) CSOLV
      READ(1,*) PHASE
      READ(1,*) DATABASE           
      READ(1,*) CPTFIL
      READ(1,*) OUTFIL
      CLOSE(1)
      WRITE(*,*) CSOLV,PHASE,DATABASE,CPTFIL
     
C     Initialise MT-DATA
      CALL START_MT(DATABASE,ERFLAG)
      CALL CHKERR(ERFLAG)
      CALL MTDATA_RESERVE_UNIT(12)
      CALL MTDATA_RESERVE_UNIT(13)

      CHECK=0
      NSOLV=INIT_COMPONENT_NO(CSOLV)

C     Load composition and temperature from file
      CALL READ_SET(CPTFIL,INIT_NO_OF_COMPONENTS(),ERFLAG,CHOICE)

C     Modelling time
      WRITE(*,*)
      WRITE(*,*) 'Enter modelling time (in seconds):'
      READ(*,*) MT

C     Initialise nodes
      IF (MOD(NNODES,2).NE.0) THEN
         NNODES=NNODES+1
      ENDIF
      ORIGIN=0.0
      TIME=0.0D0
      SHIFT=DELX
      I=1
      VOLM=7.0D-6

      CALL INIT_PROFIL(NSOLV,NNODES,DELX,ORIGIN,0,DIS)
      DO 1 NODE=0,5 
         WRITE(*,*) (PROFIL(J,NODE),J=1,INIT_NO_OF_COMPONENTS())
 1    CONTINUE
      CALL NODE_INFO(0,NNODES+1,PHASE,MAX)


C     Find Tie_line
      DO 2 J=1,INIT_NO_OF_COMPONENTS()
         COMPO(J)=PROFIL(J,NNODES)
         CARBON=(PROFIL(4,NNODES)*DIS)/VOLM
 2    CONTINUE

      CALL ISOVELOCITY(DELX,MAX,PHASE,COMPO,CHOICE,VELOC,VLAST)
      
      WRITE(*,*) 'Number of nodes: ',NNODES
      WRITE(*,*) 'Starting with spacing of: ',DELX
      WRITE(*,*) 'Enter time step:'
      READ(*,*) DELT
      WRITE(*,*) 'And a time step of: ',DELT
      CALL RSLT(DELX,TIME,1,OUTFIL,NNODES,ORIGIN,VF)

 10   TIME=TIME+DELT

C     Calculation of Mobility
      
      NCOM=INIT_NO_OF_COMPONENTS()
      DO 30 J=1,NNODES
         DO 40 K=1,NCOM
            COMPO(K)=PROFIL(K,J)
 40      CONTINUE
         CALL SETCOM(COMPO,CHOICE)
         CALL COMPUTE_EQUILIBRIUM()
         DO 45 K=1,NCOM
            COMPT=INIT_COMPONENT_NAME(K)
            CALL MOBILITY(COMPT,PHASE,COMPO,MOBLTY,TEMP)
            MOB(K,J)=MOBLTY
 45      CONTINUE 
 30   CONTINUE    
                
      CALL CHECK_END_NODES(1,NNODES,ANSWER)
      IF(ANSWER.EQ.1) THEN
C     extend grid to the left by -DELX
      ELSE IF(ANSWER.EQ.2) THEN
C     extend grid to right by DELX
         WRITE(*,*) 'Extending on right end'
         ODELX=DELX
         CALL MURRAY_LANDIS(NNODES,1,DELX,ORIGIN,DELX/2.0d0)
         DELT=DELT*((DELX/ODELX)**2)
         WRITE(*,*) 'New delt: ',DELT
      ELSE IF(ANSWER.EQ.3) THEN
C     extend grid on both ends
         WRITE(*,*) 'Extending on both ends'
         ODELX=DELX
         CALL MURRAY_LANDIS(NNODES,1,DELX,ORIGIN,DELX/2.0d0)
         DELT=DELT*((DELX/ODELX)**2)
         WRITE(*,*) 'New delt: ',DELT
      ENDIF     
 
      
      CALL NODE_INFO(0,NNODES+1,PHASE,MAX)
     
      WRITE(*,*) 'MAX AIK is ',AIK(0,0,0)
      IF (AIK(0,0,0).GT.1.0D0) THEN
         WRITE(*,*)
         WRITE(*,*) 'Problem, starting over with smaller step: '
         WRITE(*,*)
         I=1
         TIME=0         
         CALL INIT_PROFIL(NSOLV,NNODES,DELX,ORIGIN,0,DIS)
         CALL RSLT(DELX,TIME,2,OUTFIL,NNODES,ORIGIN,VF)
         DELT=DELT/5.0D0
         GOTO 10
      ENDIF

      CALL FICK_SECOND_LAW(1,NNODES,DELX,DELT,NSOLV)

      IF (MOD(I,10).EQ.0.0D0) THEN
         WRITE(*,*) 'Time is: ',TIME
         WRITE(*,*) (PROFIL(1,J),J=((NNODES/2)-2),(NNODES/2)+2)
         WRITE(*,*) (PROFIL(2,J),J=((NNODES/2)-2),(NNODES/2)+2)
         WRITE(*,*) (PROFIL(3,J),J=((NNODES/2)-2),(NNODES/2)+2)
         WRITE(*,*) (PROFIL(4,J),J=((NNODES/2)-2),(NNODES/2)+2)
         CALL RSLT(DELX,TIME,2,OUTFIL,NNODES,ORIGIN,VF)
      ENDIF

      DO 100 J=1,INIT_NO_OF_COMPONENTS()
         COMPO(J)=PROFIL(J,NNODES)
 100  CONTINUE
      CARBON=CARBON-(VELOC*DELT)/VOLM
      COMPO(4)=(CARBON*VOLM)/DIS

      CALL ISOVELOCITY(DELX,MAX,PHASE,COMPO,CHOICE,VELOC,VLAST)
      
      THICK=THICK+(VLAST*DELT)
      VF=THICK/DIS
    
      I=I+1
      IF (TIME.LT.MT) GOTO 10
      
 200  END

C **********************************************************************
C Subroutine CHECK_END_NODES, write current profiles to a file. 
C 
      SUBROUTINE CHECK_END_NODES(LOW,HIGH,ANSWER)

      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15,MAXNOD=700)

      INTEGER LOW,HIGH,ANSWER
      INTEGER INIT_NO_OF_COMPONENTS
      DOUBLE PRECISION LIMIT

      DOUBLE PRECISION PROFIL(MAXCPT,0:MAXNOD)
      DOUBLE PRECISION CHEMPO(MAXCPT,0:MAXNOD)
      DOUBLE PRECISION MOBIL(MAXCPT,0:MAXNOD)
      DOUBLE PRECISION MOLVOL(MAXCPT)
     
      COMMON / FSL / PROFIL,CHEMPO,MOBIL,MOLVOL

      ANSWER=0
      LIMIT=0.00005

      DO 10 I=1,INIT_NO_OF_COMPONENTS()
         IF(DABS(PROFIL(I,LOW)-PROFIL(I,LOW-1)).GT.LIMIT) THEN
            WRITE(*,*) PROFIL(I,LOW),PROFIL(I,LOW-1),
     &       DABS(PROFIL(I,LOW)-PROFIL(I,LOW-1))
            WRITE(*,*) 'Significant change for component ',I, 
     &           ' on lower end'
            ANSWER=1
         ENDIF
         IF(DABS(PROFIL(I,HIGH)-PROFIL(I,HIGH+1)).GT.LIMIT) THEN
            WRITE(*,*) 'Significant change for component ',I, 
     &           ' on higher end'
            ANSWER=ANSWER+2
         ENDIF
 10   CONTINUE
      END
            


C **********************************************************************
C Subroutine RSLT, write current profiles to a file. 
C 
      SUBROUTINE RSLT(DX,TIME,Z,OUTFIL,NNODES,ORIGIN,VF)

      INTEGER Z,I,NNODES
      DOUBLE PRECISION DX,TIME,ORIGIN,VF
      CHARACTER*2 INIT_COMPONENT_NAME
      CHARACTER*20 OUTFIL

      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15,MAXNOD=700)
      DOUBLE PRECISION WFE(MAXCPT,0:MAXNOD),WCR(MAXCPT,0:MAXNOD)
      DOUBLE PRECISION WNI(MAXCPT,0:MAXNOD)
      DOUBLE PRECISION WC(MAXCPT,0:MAXNOD), PFE(MAXCPT,0:MAXNOD)
      DOUBLE PRECISION PCR(MAXCPT,0:MAXNOD)
      DOUBLE PRECISION PNI(MAXCPT,0:MAXNOD),PC(MAXCPT,0:MAXNOD)
      DOUBLE PRECISION TOT(0:MAXNOD)
      DOUBLE PRECISION PROFIL(MAXCPT,0:MAXNOD)
      DOUBLE PRECISION CHEMPO(MAXCPT,0:MAXNOD)
      DOUBLE PRECISION MOBIL(MAXCPT,0:MAXNOD)
      DOUBLE PRECISION MOLVOL(MAXCPT)
      COMMON / FSL / PROFIL,CHEMPO,MOBIL,MOLVOL

      IF (Z.EQ.1) THEN
         OPEN(UNIT=12,FILE=OUTFIL)
         WRITE(12,100) 'Time/s ',' Distance/m ','Fe/wt%','Cr/wt%',
     & 'Ni/wt%','C/wt%','VF'
         DO 10 I=0,NNODES
            WFE(1,I)=PROFIL(1,I)*55.85
            WCR(2,I)=PROFIL(2,I)*52
            WNI(3,I)=PROFIL(3,I)*58.69
            WC(4,I)=PROFIL(4,I)*12.01
            TOT(I)=WFE(1,I)+WCR(2,I)+WNI(3,I)+WC(4,I)
            
            PFE(1,I)=(WFE(1,I)/TOT(I))*100
            PCR(2,I)=(WCR(2,I)/TOT(I))*100
            PNI(3,I)=(WNI(3,I)/TOT(I))*100
            PC(4,I)=(WC(4,I)/TOT(I))*100
            
            WRITE(12,200) TIME,ORIGIN+FLOAT(I)*DX,
     &           PFE(1,I),PCR(2,I),PNI(3,I),PC(4,I),VF
 10      CONTINUE
      ELSEIF (Z.EQ.2) THEN
         DO 20 I=0,NNODES
            WFE(1,I)=PROFIL(1,I)*55.85
            WCR(2,I)=PROFIL(2,I)*52
            WNI(3,I)=PROFIL(3,I)*58.69
            WC(4,I)=PROFIL(4,I)*12.01
            TOT(I)=WFE(1,I)+WCR(2,I)+WNI(3,I)+WC(4,I)
            
            PFE(1,I)=(WFE(1,I)/TOT(I))*100
            PCR(2,I)=(WCR(2,I)/TOT(I))*100
            PNI(3,I)=(WNI(3,I)/TOT(I))*100
            PC(4,I)=(WC(4,I)/TOT(I))*100
            
            WRITE(12,200) TIME,ORIGIN+FLOAT(I)*DX,
     &           PFE(1,I),PCR(2,I),PNI(3,I),PC(4,I),VF
 20      CONTINUE
      ELSEIF(Z.EQ.3) THEN
         CLOSE(12)
      ENDIF

 100  FORMAT(A10,A12,5(1X,A10))
 200  FORMAT(F,F,5(1X,E12.6))
      END


C **********************************************************************
C Subroutine INIT_PROFIL, for testing purposes only
C NSOLV component number for the solvent, in the initial list
C NNODES, the number of nodes to use, this is returned by the subroutine
C DLX, the calculated spacing, returned
C ORIGIN, the origin of the grid (from ancilliary node)
C ACCEPT=0/1 if 1, no interactive mode

      SUBROUTINE INIT_PROFIL(NSOLV,NNODES,DLX,ORIGIN,ACCEPT,DIS)

      INTEGER NNODES,NSOLV,ACCEPT
      DOUBLE PRECISION DLX,ORIGIN

      CHARACTER*200 COMMENTS
      DOUBLE PRECISION DLY,XX
      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15,MAXNOD=700)

      INTEGER ANSWER,INIT_NO_OF_COMPONENTS,I,J,K,BASE,NODE,MAXST,MAXGRI
      DOUBLE PRECISION STONE(0:MAXCPT,10),MAXGRD,SUM(0:MAXNOD)
      DOUBLE PRECISION DIS
      
      DOUBLE PRECISION PROFIL(MAXCPT,0:MAXNOD)
      DOUBLE PRECISION CHEMPO(MAXCPT,0:MAXNOD)
      DOUBLE PRECISION MOBIL(MAXCPT,0:MAXNOD)
      DOUBLE PRECISION MOLVOL(MAXCPT)
      DOUBLE PRECISION AIK(MAXCPT,MAXCPT,0:MAXNOD)
      COMMON / FSL / PROFIL,CHEMPO,MOBIL,MOLVOL,AIK

      MAXST=10
      DO 5 I=1,MAXNOD
         SUM(I)=0
 5    CONTINUE

C     Read points defining the profiles
      OPEN(UNIT=13,FILE='PROFILE',STATUS='OLD',ERR=666)
      READ(13,*)
      READ(13,*)
      I=1
 10   READ(13,*,END=20) STONE(0,I),
     & (STONE(J,I),J=1,INIT_NO_OF_COMPONENTS())
      
      I=I+1
      IF(I.GT.MAXST) THEN
         WRITE(*,*) 'Maximum number of points is ',MAXST
         WRITE(*,*) 'Skipping other profile points'
         RETURN
      ENDIF
      GOTO 10
 20   CLOSE(13)

      MAXST=I-1
      WRITE(*,*) I,' points found to define profiles.'
      MAXGRD=0.0D0


C     convert positions in profile to meters (input must be in microns)
      DO 22 I=1,MAXST
         STONE(0,I)=STONE(0,I)*1.0e-06
         DIS=STONE(0,MAXST)
 22   CONTINUE


C     get the largest gradient, and estimate number of nodes required
      DO 30 I=2,MAXST
         DLX=STONE(0,I)-STONE(0,I-1)
         DO 25 J=1,INIT_NO_OF_COMPONENTS()
            IF(DABS((STONE(J,I)-STONE(J,I-1))/DLX).GT.MAXGRD) THEN
               MAXGRD=DABS((STONE(J,I)-STONE(J,I-1))/DLX)
               MAXGRI=I
            ENDIF
 25      CONTINUE
 30   CONTINUE
      DLX=STONE(0,MAXGRI)-STONE(0,MAXGRI-1)
      WRITE(*,*) 'Largest gradient is: ',MAXGRD,' over ',DLX
      DLX=DLX/30.0
      NNODES=IDINT((STONE(0,MAXST)-STONE(0,1))/DLX)


C     Make sure the number of nodes is even
      IF (MOD(NNODES,2).NE.0) NNODES=NNODES+1
      DLX=(STONE(0,MAXST)-STONE(0,1))/DBLE(NNODES-1)
      WRITE(*,*) 'Recommended number of nodes: ',NNODES
      WRITE(*,*) 'With spacing: ',DLX


C     Give possibility to reject default number of nodes
      IF (ACCEPT.EQ.0) THEN
         WRITE(*,*) 
 32      WRITE(*,*) 'Accept number of nodes ? (1/0)'
         WRITE(*,*)
         READ(*,*,ERR=32) ANSWER
         IF (ANSWER.EQ.0) THEN
 33         WRITE(*,*) 'Enter number of nodes: '
            READ(*,*,ERR=33) NNODES
            DLX=(STONE(0,MAXST)-STONE(0,1))/DBLE(NNODES-1)
            WRITE(*,*) 'New spacing: ',DLX
         ELSEIF(ANSWER.NE.1) THEN
            GOTO 32
         ENDIF
      ENDIF

C     create the grid from the points read
      J=0
      BASE=1
      DO 40 I=2,MAXST
 36      J=J+1
         IF((DBLE(J)*DLX).GE.STONE(0,I)) THEN
            DO 35 K=1,INIT_NO_OF_COMPONENTS()
               DLY=STONE(K,I)-STONE(K,I-1)
               DO 37 NODE=BASE,J
                  XX=DBLE(NODE-BASE)/DBLE(J-BASE)
                  PROFIL(K,NODE)=STONE(K,I-1)
     &                 -6.0D0*DLY*(((XX**3)/3.0)-((XX**2)/2.0))
                  SUM(NODE)=SUM(NODE)+PROFIL(K,NODE)
 37            CONTINUE
 35         CONTINUE
            DO 38 NODE=BASE,J
               PROFIL(NSOLV,NODE)=1.0D0-SUM(NODE)
 38         CONTINUE
            BASE=J+1
         ELSE
            GOTO 36
         ENDIF
 40   CONTINUE

C     any points left ? make equal to previous
 42   IF(J.LE.NNODES) THEN
         WRITE(*,*) 'J is ',J,' and NNODES: ',NNODES
         DO 45 K=1,INIT_NO_OF_COMPONENTS()
            WRITE(*,*) PROFIL(K,J-1),PROFIL(K,J)
            PROFIL(K,J)=PROFIL(K,J-1)
 45      CONTINUE
         J=J+1
         GOTO 42

      ENDIF

C     prepare ancilliary nodes
      DO 50 K=1,INIT_NO_OF_COMPONENTS()
         PROFIL(K,0)=PROFIL(K,1)
         PROFIL(K,NNODES+1)=PROFIL(K,NNODES)
 50   CONTINUE

C     load molar volumes, this is a temporary solution
      DO 60 I=1,MAXCPT
         MOLVOL(I)=7.0E-06
 60   CONTINUE

      WRITE(*,*) ORIGIN
      GOTO 777
 666  WRITE(*,*) 'Error: could not open profiles file.' 
      RETURN
 777  END

C **********************************************************************
C SUBROUTINE MURRAY_LANDIS(LOW,HIGH,DELX,ORIGIN,SHIFT)
C shift the grid by 'shift' which can be < 0 or > 0
C e.g. MURRAY_LANDIS(50,1,DELX,-DELX) shifts node 50 by DELX to the left, while
C      node 1 is unchanged (and all in between move proportionaly). Grid is 
C      compressed. For grid of current spacing DELX (DELX is returned modified)
C      MURRAY_LANDIS(1,50,DELX,DELX) shifts node 1 by DELX to the right, node 
C      50 is unaffected. Grid is compressed.
C ORIGIN is the x coordinate of the first node. If it is the one shifted, then ORIGIN 
C is shifted. If the upper node is shifted, no change

      SUBROUTINE MURRAY_LANDIS(LOW,HIGH,DELX,ORIGIN,SHIFT)

      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15,MAXNOD=700)

      INTEGER LOW,HIGH
      DOUBLE PRECISION SHIFT,DELX,ORIGIN

      INTEGER INIT_NO_OF_COMPONENTS,I,J,STEP
      DOUBLE PRECISION SIGN,LENGTH,SLOPE(0:MAXNOD,2)

      DOUBLE PRECISION PROFIL(MAXCPT,0:MAXNOD)
      DOUBLE PRECISION CHEMPO(MAXCPT,0:MAXNOD)
      DOUBLE PRECISION MOBIL(MAXCPT,0:MAXNOD)
      DOUBLE PRECISION MOLVOL(MAXCPT)
      DOUBLE PRECISION AIK(MAXCPT,MAXCPT,0:MAXNOD)

      COMMON / FSL / PROFIL,CHEMPO,MOBIL,MOLVOL,AIK

      STEP=1
      IF(LOW.GT.HIGH) STEP=-1

      DO 10 I=1,INIT_NO_OF_COMPONENTS()
         DO 20 J=LOW,HIGH,STEP
            SLOPE(J,1)=(PROFIL(I,J+1)-PROFIL(I,J-1))/(2.0*DELX)
 20      CONTINUE

C        then update concentration profile for this component
         DO 30 J=LOW,HIGH,STEP
            RATIO=DBLE(HIGH-J)/DBLE(HIGH-LOW)
            PROFIL(I,J)=PROFIL(I,J)+(RATIO*SHIFT*SLOPE(J,1))
 30      CONTINUE
 10   CONTINUE

C     this is negative if we are shifting the lower end, times the shift should give 
C     longer grid if positive shift at high end or neg shift at low end.
      SIGN=DBLE(LOW-HIGH)/DABS(DBLE(LOW-HIGH))
      WRITE(*,*) 'SIGN of shift:',SIGN
      LENGTH=DABS(DBLE(HIGH-LOW))*DELX+(SIGN*SHIFT)
      DELX=LENGTH/DABS(DBLE(HIGH-LOW))
      WRITE(*,*) 'New spacing: ',DELX

C     Correct to keep track of the absissa of the lower node
      IF(SIGN.LT.0.0D0) THEN
         WRITE(*,*)'Lower node shifted, changing origin'
         ORIGIN=ORIGIN+SHIFT
      ENDIF

      END


C **********************************************************************
C Subroutine NODE_INFO 
C calculate the chemical potentials and mobilities at each node in 
C provided range for all components.

      SUBROUTINE NODE_INFO(LOW,HIGH,PHASE,MAX)

      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15,MAXNOD=700)

      CHARACTER*20 PHASE,FAKE
      INTEGER LOW,HIGH
      DOUBLE PRECISION MAX
      INTEGER NODE,I,K
      INTEGER NCOM,INIT_NO_OF_COMPONENTS
      CHARACTER*2 INIT_COMPONENT_NAME,COMPT
      DOUBLE PRECISION PARTIAL_SYSTEM_GIBBS_ENERGY
      DOUBLE PRECISION MOBLTY,NODEC(MAXCPT),DIRAC

      DOUBLE PRECISION PROFIL(MAXCPT,0:MAXNOD)
      DOUBLE PRECISION CHEMPO(MAXCPT,0:MAXNOD)
      DOUBLE PRECISION MOBIL(MAXCPT,0:MAXNOD)
      DOUBLE PRECISION AIK(MAXCPT,MAXCPT,0:MAXNOD)
      DOUBLE PRECISION MOLVOL(MAXCPT)


      DOUBLE PRECISION TEMP,PRESS

      COMMON / FSL / PROFIL,CHEMPO,MOBIL,MOLVOL,AIK
      COMMON / TP / TEMP,PRESS

      NCOM=INIT_NO_OF_COMPONENTS()

      AIK(0,0,0)=0.0D0

      DO 100 NODE=LOW,HIGH
C        temporary table with composition at node I
         DO 10 I=1,NCOM
            NODEC(I)=PROFIL(I,NODE)
 10      CONTINUE
C        set as composition, must be in mole fraction/moles
         CALL SETCOM(NODEC,2)
         CALL ONLYNORM(PHASE,FAKE)
         CALL COMPUTE_EQUILIBRIUM()
         DO 20 I=1,NCOM
C        Get the chemical coefs and mobility, ensure 0 if component 0.
            IF (NODEC(I).NE.0.0D0) THEN
               CHEMPO(I,NODE)=PARTIAL_SYSTEM_GIBBS_ENERGY(I)
            ELSE
               CHEMPO(I,NODE)=0.0D0
            ENDIF
 20      CONTINUE

         DO 25 I=1,NCOM
         IF (NODEC(I).NE.0.0D0) THEN
            COMPT=INIT_COMPONENT_NAME(I)
            CALL MOBILITY(COMPT,PHASE,NODEC,MOBLTY,TEMP)
            MOBIL(I,NODE)=MOBLTY
         ELSE 
            MOBIL(I,NODE)=0.0D0
         ENDIF
 25      CONTINUE
            
         VOLM=0.0D0
         DO 30 I=1,NCOM
            VOLM=VOLM+(PROFIL(I,NODE)*MOLVOL(I))
 30      CONTINUE
         
         DO 40 I=1,NCOM
            DO 50 K=1,NCOM
               AIK(I,K,NODE)=(DIRAC(I,K)-PROFIL(I,NODE)*MOLVOL(K)/VOLM)
     &              *PROFIL(K,NODE)*MOBIL(K,NODE)
               IF (DABS(AIK(I,K,NODE)).GT.AIK(0,0,0)) 
     &              AIK(0,0,0)=DABS(AIK(I,K,NODE))
 50         CONTINUE
 40      CONTINUE

 100  CONTINUE

      MAX=AIK(0,0,0)

      END


C **********************************************************************
C Subroutine FICK_SECOND_LAW
C Calculates dc/dt between nodes LOW and HIGH

      SUBROUTINE FICK_SECOND_LAW(LOW,HIGH,DELX,DELT,NSOLV)

      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15,MAXNOD=700)

      INTEGER LOW,HIGH,NSOLV
      DOUBLE PRECISION DELX,DELT

      INTEGER NODE,I,K
      INTEGER NCOM,INIT_NO_OF_COMPONENTS
      DOUBLE PRECISION A,DIRAC
      DOUBLE PRECISION DC(MAXCPT,0:MAXNOD),SUMDC

      DOUBLE PRECISION PROFIL(MAXCPT,0:MAXNOD)
      DOUBLE PRECISION CHEMPO(MAXCPT,0:MAXNOD)
      DOUBLE PRECISION MOBIL(MAXCPT,0:MAXNOD)
      DOUBLE PRECISION MOLVOL(MAXCPT)
      DOUBLE PRECISION AIK(MAXCPT,MAXCPT,0:MAXNOD)

      COMMON / FSL / PROFIL,CHEMPO,MOBIL,MOLVOL,AIK

      NCOM=INIT_NO_OF_COMPONENTS()

      DO 100 NODE=LOW,HIGH
         SUMDC=0.0D0
         DO 20 I=1,NCOM
            IF (I.NE.NSOLV) THEN
               A=0.0d0
               DO 25 K=1,NCOM
                  A=A+(0.5D0*(AIK(I,K,NODE+1)+AIK(I,K,NODE))*
     &                 (CHEMPO(K,NODE+1)-CHEMPO(K,NODE)))
                  A=A-(0.5D0*(AIK(I,K,NODE)+AIK(I,K,NODE-1))*
     &                 (CHEMPO(K,NODE)-CHEMPO(K,NODE-1)))
 25            CONTINUE
               DC(I,NODE)=A*DELT/(DELX*DELX)
               SUMDC=SUMDC+DC(I,NODE)
            ENDIF
 20      CONTINUE
         DC(NSOLV,NODE)=-SUMDC
 100  CONTINUE

      DO 200 NODE=LOW,HIGH
         DO 210 I=1,NCOM
            WRITE(*,*) 'Change for component ',I,': ',DC(I,NODE)
            PROFIL(I,NODE)=PROFIL(I,NODE)+DC(I,NODE)
 210     CONTINUE
 200  CONTINUE


      END

C **********************************************************************
C Subroutine MOBILITY
C Arguments are:
C 1/ name of the components you want mobility of
C 2/ temperature
C 3/ phase in which you want mobility
C 4/ composition of this phase in moles / mole fraction
C returns mobility in MOBLTY

      SUBROUTINE MOBILITY(COMPT,PHASE,COMPO,MOBLTY,TEMP)
      
      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15,MAXNOD=700)

      CHARACTER*2 COMPT
      CHARACTER*20 PHASE
      INTEGER I
      DOUBLE PRECISION R,TEMP,QFE,QNI,QCR,MOB_P_FE,MOB_P_NI,MOB_P_CR
      DOUBLE PRECISION MOBLTY_FE,MOBLTY_NI,MOBLTY_CR,MOBLTY,MOBLTY_C
      DOUBLE PRECISION XFE,XCR,XNI
  
      INTEGER ACT_NO_OF_COMPONENTS
      DOUBLE PRECISION MOLE_FRACTION 
      DOUBLE PRECISION ACT_COMPONENT_MOLES

      DOUBLE PRECISION COMPO(MAXCPT)
     
    
      R=8.31451

C     Calculation of mole fraction of component

      XFE=MOLE_FRACTION('Fe<FCC_A1>')
      XCR=MOLE_FRACTION('Cr<FCC_A1>')
      XNI=MOLE_FRACTION('Ni<FCC_A1>') 
     
C     Calculation of mobility

      IF (COMPT .EQ. 'Fe') THEN
         QFE=R*(35880*XFE+34410*XNI+36130*XCR)
         MOB_P_FE=(1/(R*TEMP))*(3.202D-4*XFE+3.164D-4*XNI+2.364D-4*XCR)
         MOBLTY_FE=MOB_P_FE*EXP(-QFE/(R*TEMP))
         MOBLTY=MOBLTY_FE
      ELSE IF (COMPT .EQ. 'Cr') THEN
         QCR=R*(36100*XFE+32080*XNI+34620*XCR)
         MOB_P_CR=(1/(R*TEMP))*(2.747D-4*XFE+1.117D-4*XNI+1.444D-4*XCR)
         MOBLTY_CR=MOB_P_CR*EXP(-QCR/(R*TEMP))
         MOBLTY=MOBLTY_CR
      ELSE IF (COMPT .EQ. 'Ni') THEN
         QNI=R*(35650*XFE+34600*XNI+38010*XCR)
         MOB_P_NI=(1/(R*TEMP))*(1.111D-4*XFE+3.808D-4*XNI+1.542D-4*XCR)
         MOBLTY_NI=MOB_P_NI*EXP(-QNI/(R*TEMP))
         MOBLTY=MOBLTY_NI   
      ELSE 
         MOBLTY=0.0
      ENDIF

      END


C **********************************************************************
C Subroutine ONLYNORM
C This subroutine classifies normal the phase whose names are 
C passed as arguments and absent all the others.

      SUBROUTINE ONLYNORM(PI,PII)

      CHARACTER*20 PI,PII
      CHARACTER*20 PVAR
      CHARACTER*20 INIT_PHASE_NAME
      INTEGER INIT_NO_OF_PHASES

      DO 10 I=1,INIT_NO_OF_PHASES()
         PVAR=INIT_PHASE_NAME(I)

         IF (PVAR.EQ.PI .OR. PVAR.EQ.PII) THEN 
            CALL SET_INIT_PHASE_CLASS(I,1)
         ELSE
            CALL SET_INIT_PHASE_CLASS(I,0) 
         ENDIF
 10   CONTINUE
      END


C **********************************************************************
C Subroutine START_MT
C Initialises MT-DATA with the mpi file passed as argument MPINAM, 
C prompt for for a file name if Z=1

      SUBROUTINE START_MT(DATABASE,ERFLAG)

      INTEGER IMODE,IERR,ERFLAG
      CHARACTER*20 FILE2,DATABASE

      WRITE(*,*) 'Subroutine START_MT: initialising MT-DATA with mpi',
     & ' file: ',DATABASE

      CALL INITIALISE_MTDATA(IMODE)
      CALL SGUMEN(1) 
      CALL SGUMEN(2)
      CALL MTOPTN(IMODE,'STAGE_1=NEW')
      FILE2='def'
      IERR=0
      IMODE=0

 20   CALL OPEN_MPI_FILE(DATABASE, FILE2, IERR)
      CALL SET_PRINT_LEVEL(-2)

      IF(IERR.NE.0) THEN
         WRITE(*,*)'Failure in MPI file reading', IERR
         WRITE(*,*)
         ERFLAG=1
         GOTO 666
      ENDIF

      CALL SET_PRESSURE(101325.0D0)

      CALL DISP_COMPONENTS(1)
      CALL DISP_PHASES

      GOTO 777

 666  WRITE(*,*) 'Subroutine MT_START: wrong mpi file name'

 777  END


C **********************************************************************
C Subroutine READ_SET
C Read a file FILNAM containing the number of components (checked against 
C N, the number in current system), whether the values are mass or moles, 
C and the values themselves. If an error occurs, ERFLAG is set to 1.
C Returns M=1 if mass, M=2 if moles

      SUBROUTINE READ_SET(FILNAM,N,ERFLAG,M)

      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15,MAXNOD=700)

      CHARACTER*21 COMENT
      CHARACTER*20 FILNAM,FAKE
      INTEGER I,N,M,ERFLAG

      DOUBLE PRECISION TEMP,PRESS
      DOUBLE PRECISION COMPO(MAXCPT)
      COMMON / TP / TEMP,PRESS
      COMMON / INPUT / COMPO

      OPEN(UNIT=1,STATUS='OLD',FILE=FILNAM,ERR=5)
      READ(1,*)
      READ(1,*)
      READ(1,*)
      READ(1,*)
      READ(1,*) M
      IF (N.NE.M) THEN
 5       ERFLAG=1
         GOTO 666
      ENDIF

      READ(1,*) M

      IF(M.EQ.1) THEN
         COMENT='WEIGHT PERCENT TABLE '
      ELSEIF(M.EQ.2) THEN
         COMENT='MOLE FRACTION TABLE '
      ENDIF

      READ(1,*) TEMP

      DO 10 I=1,N
         READ(1,*) COMPO(I)
 10   CONTINUE

      CALL SET_TEMPERATURE(TEMP)
      CALL SETCOM(COMPO,M)
      WRITE(*,*) COMENT//' SUCCESFULLY READ'

      CALL DISP_COMPONENTS(3)
      
 666  CLOSE(1)
      END


C *******************************************************************
C Subroutine SETCOM
C Sets the composition passed in argument as TABLEC, 
C CHOICE=1 for mass, CHOICE=2 for moles

      SUBROUTINE SETCOM(TABLEC,CHOICE)

      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15,MAXNOD=700)

      INTEGER CHOICE,I,INIT_NO_OF_COMPONENTS
      DOUBLE PRECISION TABLEC(MAXCPT)

      IF (CHOICE.EQ.1) THEN
      DO 10 I=1,INIT_NO_OF_COMPONENTS()
         CALL SET_INIT_COMPONENT_MASS(I,TABLEC(I))
10    CONTINUE
      ENDIF

      IF (CHOICE.EQ.2) THEN
      DO 20 I=1,INIT_NO_OF_COMPONENTS()
         CALL SET_INIT_COMPONENT_AMOUNT(I,TABLEC(I))
 20   CONTINUE
      ENDIF
       END


C **********************************************************************
C Subroutine DISP_MENU(NLINES,LINE) displays a formatted menu placed in
C the character array LINE by the subroutine MENU_X.
C 
      SUBROUTINE DISP_MENU()
      INTEGER NLINES
      CHARACTER *50 LINE(15)
      COMMON / MENU / NLINES,LINE

      WRITE(*,60)      
      WRITE(*,70)
      WRITE(*,80)
      WRITE(*,110) LINE(1)
      WRITE(*,80)
      DO 10 I=2,NLINES
         WRITE(*,100) LINE(I)
 10      CONTINUE
      WRITE(*,80)
      WRITE(*,70)
      WRITE(*,120)
 
 60   FORMAT (30(/))
 70   FORMAT (5X,70('*'))
 80   FORMAT (5X,'*',68X,'*')
 100  FORMAT (5X,'*',9X,A,9X,'*')
 110  FORMAT (5X,5('*'),5X,A,5X,5('*'))
 120  FORMAT (5(/))
      
      END


C *******************************************************************
C Subroutine DISP_COMPONENTS
C argument CHOICE: 1 / name of initial components
C                  2 / mass of initial components
C                  3 / moles of initial components
C                  4 / name of active components (after eq calc only)

      SUBROUTINE DISP_COMPONENTS(CHOICE)

      INTEGER CHOICE

      DOUBLE PRECISION INIT_COMPONENT_MASS
      DOUBLE PRECISION INIT_COMPONENT_MOLES
      INTEGER ACT_NO_OF_COMPONENTS
      CHARACTER*2 INIT_COMPONENT_NAME,ACT_COMPONENT_NAME

      WRITE(*,*)

      IF (CHOICE.EQ.1) THEN
      DO 10 I=1,INIT_NO_OF_COMPONENTS()
         WRITE(*,100) 'Component',I,'is',INIT_COMPONENT_NAME(I)
 10   CONTINUE
      ENDIF

      IF (CHOICE.EQ.2) THEN 
      DO 20 I=1,INIT_NO_OF_COMPONENTS()
       WRITE(*,150) INIT_COMPONENT_NAME(I),' mass: ',
     & INIT_COMPONENT_MASS(I)
 20   CONTINUE
      ENDIF

      IF(CHOICE.EQ.3) THEN
         DO 30 I=1,INIT_NO_OF_COMPONENTS()
            WRITE(*,200) 'Component',I,'amount in moles is',
     &      INIT_COMPONENT_MOLES(I)
 30      CONTINUE
      ENDIF

      IF (CHOICE.EQ.4) THEN 
         DO 40 I=1,ACT_NO_OF_COMPONENTS()
            WRITE(*,100) 'Active Component', I, 'is',
     &       ACT_COMPONENT_NAME(I)
 40         CONTINUE
      ENDIF

 100  FORMAT (10X,A,1X,I2,1X,A,1X,A)
 150  FORMAT (10X,A,1X,A,1X,F7.4)
 200  FORMAT (10X,A,1X,I2,1X,A,1X,F7.4)
      END


C *******************************************************************
C Subroutine DISP_PHASES
C display the different phases loaded with the mpi file and their 
C current status


      SUBROUTINE DISP_PHASES()
      CHARACTER*20 INIT_PHASE_NAME
      CHARACTER*6 ANSW
      WRITE(*,*)
      DO 10 I=1,INIT_NO_OF_PHASES()
         IF (NORMAL_INIT_PHASE(I)) THEN 
            ANSW='normal'
            ELSE
            ANSW='absent'
         ENDIF
         WRITE(*,100) 'The phase',INIT_PHASE_NAME(I),'is', ANSW
 10   CONTINUE
 100  FORMAT (A,1X,A,1X,A,1X,A)
      END


C ********************************************************************
C Subroutine DISP_RESULT(K)
C displays the result of the last equilibrium calculation
C argument K: 1/ mass of phases and compositions in wt%
C             2/ moles of phases and compositions in mole fraction

      SUBROUTINE DISP_RESULT(K)
      
      INTEGER K,I,J,L,M,N
      INTEGER EQUIL_NO_OF_PHASES,ACT_NO_OF_COMPONENTS
      INTEGER PHASE_PRESENT_AT_EQUILIBRIUM

      DOUBLE PRECISION COMPONENT_W_OF_PHASE,MASS_IN_PHASE
      DOUBLE PRECISION COMPONENT_X_OF_PHASE
      DOUBLE PRECISION MOLES_OF_COMPONENTS_IN_PHASE
      
      CHARACTER*10 ACT_PHASE_NAME
      CHARACTER*2 ACT_COMPONENT_NAME

      L=ACT_NO_OF_COMPONENTS()
      WRITE(*,*) EQUIL_NO_OF_PHASES()
      WRITE(*,*)

      IF (K.EQ.1) THEN
         WRITE(*,*)'Weight and components weight fractions'
         WRITE(*,300)
         DO 10 I=1,EQUIL_NO_OF_PHASES()
            N=PHASE_PRESENT_AT_EQUILIBRIUM(I)

         IF (L.GT.5) THEN
          WRITE(*,100) ACT_PHASE_NAME(N),
     &    (ACT_COMPONENT_NAME(J), J=1,5)
          WRITE(*,200) MASS_IN_PHASE(N,2),
     &    (COMPONENT_W_OF_PHASE(J,N,2), J=1,5)
          WRITE(*,*)
         ELSE 
        WRITE(*,100) ACT_PHASE_NAME(N),
     &  (ACT_COMPONENT_NAME(J), J=1,ACT_NO_OF_COMPONENTS())
        WRITE(*,200) MASS_IN_PHASE(N,2),
     &  (COMPONENT_W_OF_PHASE(J,N,2), J=1,ACT_NO_OF_COMPONENTS())
         GOTO 21
         ENDIF

         IF (L.GT.10) THEN 
            WRITE(*,400) (ACT_COMPONENT_NAME(J),J=6,10)
            WRITE(*,500) (COMPONENT_W_OF_PHASE(J,N,2), J=6,10)
            WRITE(*,*)
         ELSE
            M=6
            GOTO 20
         ENDIF

         IF (L.GT.15) THEN 
            WRITE(*,400) (ACT_COMPONENT_NAME(J),J=11,15)
            WRITE(*,500) (COMPONENT_W_OF_PHASE(J,N,2), J=11,15)
            WRITE(*,*)
         ELSE
            M=11
            GOTO 20
         ENDIF

 20    WRITE(*,400) 
     & (ACT_COMPONENT_NAME(J), J=M,ACT_NO_OF_COMPONENTS())
       WRITE(*,500) 
     &  (COMPONENT_W_OF_PHASE(J,N,2), J=M,ACT_NO_OF_COMPONENTS())

 21    WRITE(*,300)
       WRITE(*,*)
 10      CONTINUE
      ENDIF

      IF (K.EQ.2) THEN
         WRITE(*,*)'Moles and components mole fractions'
         WRITE(*,300)
         DO 30 I=1,EQUIL_NO_OF_PHASES()
            N=PHASE_PRESENT_AT_EQUILIBRIUM(I)

         IF (L.GT.5) THEN
          WRITE(*,100) ACT_PHASE_NAME(N),
     &    (ACT_COMPONENT_NAME(J), J=1,5)
          WRITE(*,200) MOLES_OF_COMPONENTS_IN_PHASE(N,2),
     &    (COMPONENT_X_OF_PHASE(J,N,2), J=1,5)
          WRITE(*,*)
         ELSE 
          WRITE(*,100) ACT_PHASE_NAME(N),
     &    (ACT_COMPONENT_NAME(J), J=1,ACT_NO_OF_COMPONENTS())
          WRITE(*,200) MOLES_OF_COMPONENTS_IN_PHASE(N,2),
     &   (COMPONENT_X_OF_PHASE(J,N,2), J=1,ACT_NO_OF_COMPONENTS())
          GOTO 41
         ENDIF

         IF (L.GT.10) THEN 
            WRITE(*,400) (ACT_COMPONENT_NAME(J),J=6,10)
            WRITE(*,500) (COMPONENT_X_OF_PHASE(J,N,2), J=6,10)
            WRITE(*,*)
         ELSE
            M=6
            GOTO 40
         ENDIF

         IF (L.GT.15) THEN 
            WRITE(*,400) (ACT_COMPONENT_NAME(J),J=11,15)
            WRITE(*,500) (COMPONENT_X_OF_PHASE(J,N,2), J=11,15)
            WRITE(*,*)
         ELSE
            M=11
            GOTO 40
         ENDIF

 40      WRITE(*,400) 
     &   (ACT_COMPONENT_NAME(J), J=M,ACT_NO_OF_COMPONENTS())
         WRITE(*,500) 
     &   (COMPONENT_X_OF_PHASE(J,N,2), J=M,ACT_NO_OF_COMPONENTS())
 
 41      WRITE(*,300)
         WRITE(*,*)
 
 30      CONTINUE
      ENDIF

 100  FORMAT (1X,A,1X,5(5X,A,4X))
 200  FORMAT (E11.6,1X,5(1X,F9.7,1X))
 300  FORMAT (66('-'))
 400  FORMAT (12X,5(5X,A,4X))
 500  FORMAT (12X,5(1X,F9.7,1X))

      END


C **********************************************************************
C Subroutine CHKERR
C exit with message if ERFLAG=1

      SUBROUTINE CHKERR(ERFLAG)
      INTEGER ERFLAG
      
      IF (ERFLAG.EQ.1) THEN
         WRITE(*,*) '*****************************'
         WRITE(*,*) 'Irrecoverable error, aborting'
         WRITE(*,*) '*****************************'
         STOP
      ENDIF

      END


C ********************************************************************
C function dirac...
C 

      DOUBLE PRECISION FUNCTION DIRAC(I,J)
      INTEGER I,J
      IF(I.EQ.J) THEN 
         DIRAC=DBLE(1)
      ELSE
         DIRAC=DBLE(0)
      ENDIF
      END


C ********************************************************************
C CR_C_TIE_LINE
C      
      SUBROUTINE CR_C_TIE_LINE(COMPO,PHASE,CHOICE,UCFAR)
      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15,MAXNOD=700)
      INTEGER CHOICE
      CHARACTER*20 PHASE,FAKE
      
      INTEGER EQUIL_NO_OF_PHASES
      INTEGER INIT_COMPONENT_NO
      DOUBLE PRECISION PARTIAL_SYSTEM_GIBBS_ENERGY
         
      DOUBLE PRECISION SIGN,STEPCR
      DOUBLE PRECISION UCFAR,UCEQ,UCNEW,UBEGIN,UFINAL,ISO
      DOUBLE PRECISION X,Y,B,CR

      DOUBLE PRECISION COMPO(MAXCPT)
      DOUBLE PRECISION PROFIL(MAXCPT,0:MAXNOD)
      DOUBLE PRECISION CHEMPO(MAXCPT,0:MAXNOD)
      DOUBLE PRECISION MOBIL(MAXCPT,0:MAXNOD)
      DOUBLE PRECISION MOLVOL(MAXCPT)
      DOUBLE PRECISION AIK(MAXCPT,MAXCPT,0:MAXNOD)

      COMMON / FSL / PROFIL,CHEMPO,MOBIL,MOLVOL,AIK


C Calculate chemical potential at equilibrium
  
      FAKE='M23C6'
      SIGN=1.0D0
      STEPCR=COMPO(2)/30.0D0
        
            CALL SETCOM(COMPO,CHOICE)
      CALL ONLYNORM(PHASE,FAKE)
      CALL COMPUTE_EQUILIBRIUM
      CALL DISP_RESULT(2)
      UCEQ=PARTIAL_SYSTEM_GIBBS_ENERGY(INIT_COMPONENT_NO('C'))
            
C Check no of equilibrium phases

      IF(EQUIL_NO_OF_PHASES().EQ.1) THEN
         WRITE(*,*) 'NO OF EQUILIBRIUM PHASES:',EQUIL_NO_OF_PHASES()
         GOTO 20
      ENDIF
  
C Calculate new chemical potential

 10   UBEGIN=UCEQ-UCFAR
      COMPO(2)=COMPO(2)+(SIGN*STEPCR)
      COMPO(1)=COMPO(1)-(SIGN*STEPCR)
      
      CALL SETCOM(COMPO,CHOICE)
      CALL ONLYNORM(PHASE,FAKE)
      CALL COMPUTE_EQUILIBRIUM
      UCNEW=PARTIAL_SYSTEM_GIBBS_ENERGY(INIT_COMPONENT_NO('C'))
      UFINAL=UCNEW-UCFAR
      
C Check no of equilibrium phases

      IF(EQUIL_NO_OF_PHASES().EQ.1) THEN
         WRITE(*,*) 'NO OF EQUILIBRIUM PHASES:',EQUIL_NO_OF_PHASES()
         GOTO 20
      ENDIF

C Get the isoactivity tie-line
      
      IF(DABS(UFINAL).GT.DABS(UBEGIN)) THEN
         SIGN=-1.0D0*SIGN
         UCEQ=UCNEW
         GOTO 10
      ELSE
         IF((UFINAL*UBEGIN).LT.0.0D0) THEN
            X=COMPO(2)-(SIGN*STEPCR)
            Y=COMPO(2)
            CR=(((UCFAR-UCEQ)/(UCNEW-UCEQ))*(Y-X))+X
            B=COMPO(2)-CR
            COMPO(1)=COMPO(1)+B
            CALL SETCOM(COMPO,CHOICE)
            CALL ONLYNORM(PHASE,FAKE)
            CALL COMPUTE_EQUILIBRIUM()
            ISO=PARTIAL_SYSTEM_GIBBS_ENERGY(INIT_COMPONENT_NO('C'))
            WRITE(*,*) 'ISOACTIVITY',ISO
         ELSE
            UCEQ=UCNEW
            GOTO 10
         ENDIF
      ENDIF

 20   END    


C ************************************************************************
C ISOVELOCITY
C      
      SUBROUTINE ISOVELOCITY(DELX,MAX,PHASE,COMPO,CHOICE,VELOC,VLAST)
      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15,MAXNOD=700)
      INTEGER I,K,L,Q,M,N,ITER,CHOICE,NODE
      CHARACTER*20 PHASE,FAKE
  
      INTEGER EQUIL_NO_OF_PHASES
      INTEGER INIT_NO_OF_COMPONENTS
      INTEGER INIT_COMPONENT_NO
      INTEGER ACT_PHASE_NO
      DOUBLE PRECISION C1,C2
      DOUBLE PRECISION PARTIAL_SYSTEM_GIBBS_ENERGY
      DOUBLE PRECISION COMPONENT_X_OF_PHASE
      
      DOUBLE PRECISION UCFAR
      DOUBLE PRECISION SIGN1,STEPNI
      DOUBLE PRECISION XF1(MAXCPT),XF2(MAXCPT),XF3(MAXCPT),XF4(MAXCPT)
      DOUBLE PRECISION A,A1,J(MAXCPT),V(MAXCPT),DELX,MAX
      DOUBLE PRECISION VBEGIN,VFINAL,VELOC
      DOUBLE PRECISION VNI_OLD,VCR_OLD,VLAST
      DOUBLE PRECISION W,Z,F,S,T,NI
 
      DOUBLE PRECISION COMPO(MAXCPT)
      DOUBLE PRECISION PROFIL(MAXCPT,0:MAXNOD)
      DOUBLE PRECISION CHEMPO(MAXCPT,0:MAXNOD)
      DOUBLE PRECISION MOBIL(MAXCPT,0:MAXNOD)
      DOUBLE PRECISION MOLVOL(MAXCPT)
      DOUBLE PRECISION AIK(MAXCPT,MAXCPT,0:MAXNOD)

      COMMON / FSL / PROFIL,CHEMPO,MOBIL,MOLVOL,AIK


      SIGN1=1.0D0
      STEPNI=COMPO(3)/25.0D0
      ITER=0
      C1=0.0D0
      C2=0.0D0
      THICK=0.0D0

C Calculate far field carbon chemical potential

      FAKE=''
      CALL SETCOM(COMPO,CHOICE)
      CALL ONLYNORM(PHASE,FAKE)
      CALL COMPUTE_EQUILIBRIUM()
      CALL DISP_RESULT(2)
      UCFAR=PARTIAL_SYSTEM_GIBBS_ENERGY(INIT_COMPONENT_NO('C'))

C Get isoactivity tie-line

      FAKE='M23C6'
      CALL CR_C_TIE_LINE(COMPO,PHASE,CHOICE,UCFAR)

C Calculate initial flux and velocity

 10   NODE=0

      DO 20 I=1,INIT_NO_OF_COMPONENTS()
         PROFIL(I,0)=COMPO(I)
 20   CONTINUE
      CALL NODE_INFO(0,3,PHASE,MAX)

      DO 30 K=1,INIT_NO_OF_COMPONENTS()
         A=0.0D0
         DO 40 L=1,INIT_NO_OF_COMPONENTS()
            A=A+(AIK(K,L,NODE)*(-CHEMPO(L,NODE+2)
     &           +(4*CHEMPO(L,NODE+1))-(3*CHEMPO(L,NODE))))
 40      CONTINUE
         CALL SETCOM(COMPO,CHOICE)
         CALL ONLYNORM(PHASE,FAKE)
         CALL COMPUTE_EQUILIBRIUM()
         XF1(K)=COMPONENT_X_OF_PHASE(K,ACT_PHASE_NO('FCC_A1'),2)
         XF2(K)=COMPONENT_X_OF_PHASE(K,ACT_PHASE_NO('M23C6'),2)
         J(K)=-1.0*A/(2.0D0*DELX)
         V(K)=-1.0*J(K)/(XF2(K)-XF1(K))
 30   CONTINUE           
      
C Calculate new flux and velocity

 50   ITER=ITER+1
      IF(ITER.GT.100) THEN
         WRITE(*,*) 'NO OF PHASES:',EQUIL_NO_OF_PHASES()
         CALL DISP_RESULT(2)
      ENDIF
      
      VCR_OLD=V(2)
      VNI_OLD=V(3)
      VBEGIN=VNI_OLD-VCR_OLD
      COMPO(3)=COMPO(3)+(SIGN1*STEPNI)
      COMPO(1)=COMPO(1)-(SIGN1*STEPNI)
      CALL CR_C_TIE_LINE(COMPO,PHASE,CHOICE,UCFAR)
      
      DO 60 Q=1,INIT_NO_OF_COMPONENTS()
         PROFIL(Q,0)=COMPO(Q)
 60   CONTINUE
      CALL NODE_INFO(0,3,PHASE,MAX)

      DO 70 M=1,INIT_NO_OF_COMPONENTS()
         A1=0.0D0
         DO 80 N=1,INIT_NO_OF_COMPONENTS()
            A1=A1+(AIK(M,N,NODE)*(-CHEMPO(N,NODE+2)
     &           +(4*CHEMPO(N,NODE+1))-(3*CHEMPO(N,NODE))))
 80      CONTINUE
         CALL SETCOM(COMPO,CHOICE)
         CALL ONLYNORM(PHASE,FAKE)
         CALL COMPUTE_EQUILIBRIUM()
         XF3(M)=COMPONENT_X_OF_PHASE(M,ACT_PHASE_NO('FCC_A1'),2)
         XF4(M)=COMPONENT_X_OF_PHASE(M,ACT_PHASE_NO('M23C6'),2)
         J(M)=-1.0*A1/(2.0D0*DELX)
         V(M)=-1.0*J(M)/(XF4(M)-XF3(M))
   70   CONTINUE           
      
      VFINAL=V(3)-V(2)
      IF(DABS(VFINAL).GT.DABS(VBEGIN)) THEN
         SIGN1=-1.0*SIGN1
         GOTO 50
      ELSE
         IF((VFINAL*VBEGIN).LT.0.0D0) THEN

C Get the Ni compo at isovelocity

            W=COMPO(3)-(SIGN1*STEPNI)
            Z=COMPO(3)
            NI=(((-VBEGIN)/(VFINAL-VBEGIN))*(Z-W))+W
            F=COMPO(3)-NI
            COMPO(3)=NI
            COMPO(1)=COMPO(1)+F

C Get the isovelocity

            S=VNI_OLD
            T=V(3)
            VLAST=(((-VBEGIN)/(VFINAL-VBEGIN))*(T-S))+S
 
C Compute equilibrium and get the carbon content

            CALL SETCOM(COMPO,CHOICE)
            CALL ONLYNORM(PHASE,FAKE)
            CALL COMPUTE_EQUILIBRIUM()
            CALL DISP_RESULT(2)
            C1=COMPONENT_X_OF_PHASE(4,ACT_PHASE_NO('FCC_A1'),2)
            C2=COMPONENT_X_OF_PHASE(4,ACT_PHASE_NO('M23C6'),2)
            VELOC=VLAST*(C2-C1)
            WRITE(*,*) 'Velocity of interface',VLAST
     
         ELSE
            GOTO 50
         ENDIF
      ENDIF
      
      END
         




























